if defined?(Rake)
  require 'rake'
  Dir[File.join(File.dirname(__FILE__), 'tasks', '**/*.rake')].each { |rake| load rake }
end

module AlacrityRails
  autoload :Config,           'alacrity-rails/config'
  autoload :Client,           'alacrity-rails/client'
  autoload :Diagnostic,       'alacrity-rails/diagnostic'
  autoload :Instrumentor,     'alacrity-rails/instrumentor'
  autoload :Middleware,       'alacrity-rails/middleware'
  autoload :ServerConfig,     'alacrity-rails/server_config'
  autoload :VERSION,          'alacrity-rails/version'

  module Probe
    autoload :ActionController,        'alacrity-rails/probe/action_controller'
    autoload :ActionMailer,            'alacrity-rails/probe/action_mailer'
    autoload :ActionView,              'alacrity-rails/probe/action_view'
    autoload :ActiveModelSerializers,  'alacrity-rails/probe/active_model_serializers'
    autoload :ActiveJob,               'alacrity-rails/probe/active_job'
    autoload :ActiveRecord,            'alacrity-rails/probe/active_record'
    autoload :Excon,                   'alacrity-rails/probe/excon'
    autoload :MongoDriver,             'alacrity-rails/probe/mongo_driver'
    autoload :Sidekiq,                 'alacrity-rails/probe/sidekiq'
    autoload :SidekiqServerMiddleware, 'alacrity-rails/probe/sidekiq'

    LIST = [
      Probe::ActionController,
      Probe::ActionMailer,
      Probe::ActionView,
      Probe::ActiveJob,
      Probe::ActiveModelSerializers,
      Probe::ActiveRecord,
      Probe::MongoDriver,
      Probe::Excon,
      Probe::Sidekiq
    ].freeze
  end

  module Transaction
    autoload :Base,               'alacrity-rails/transaction/base'
    autoload :Diagnostic,         'alacrity-rails/transaction/diagnostic'
    autoload :Custom,             'alacrity-rails/transaction/custom'
    autoload :ServerStartup,      'alacrity-rails/transaction/server_startup'
    autoload :Job,                'alacrity-rails/transaction/job'
    autoload :WebRequest,         'alacrity-rails/transaction/web_request'
  end
end

require 'alacrity-rails/railtie'
