module AlacrityRails::Config
  extend self

  def self.api_token
    @api_token ||= ENV['ALACRITY_API_TOKEN']
  end
  attr_writer :api_token

  def self.enabled?
    api_token.present?
  end

  def self.collector_host
    @collector_host ||= ENV['ALACRITY_COLLECTOR_HOST'] || 'https://collector-api.alacrityapp.com'
  end

  def self.yaml_options
    @yaml_options ||= YAML.load_file(".alacrity.yml")
  rescue
    @yaml_options = {}
  end

  def self.sidekiq_enabled?
    yaml_options['sidekiq'] != false
  end
end
