module AlacrityRails
  module Probe
    class ActionController
      def self.activate
        ActiveSupport::Notifications.subscribe 'process_action.action_controller' do |name, started, finished, unique_id, data|
          AlacrityRails::Client.store_metadata(
            controller: data[:controller],
            action: data[:action],
            format: data[:format]
          )

          AlacrityRails::Client.store_timeline_event(
            event_type: 'framework',
            engine: 'ActionController',
            started_at: started,
            finished_at: finished,
          )
        end
      end
    end
  end
end
