module AlacrityRails
  module Probe
    class ActionMailer
      def self.activate
        ActiveSupport::Notifications.subscribe 'process.action_mailer' do |name, started, finished, unique_id, data|
          AlacrityRails::Client.store_timeline_event(
            name: 'Mailer',
            event_type: 'mailer',
            engine: 'ActionMailer',
            started_at: started,
            finished_at: finished,
            detail: "#{data[:mailer]}##{data[:action]}"
          )
        end
      end
    end
  end
end
