module AlacrityRails
  module Probe
    class ActionView
      def self.activate
        ActiveSupport::Notifications.subscribe(/render_template.action_view/) do |name, started, finished, unique_id, data|
          AlacrityRails::Client.store_timeline_event(
            name: 'Template',
            event_type: 'template',
            engine: 'ActionView',
            started_at: started,
            finished_at: finished,
            detail: data[:identifier]
          )
        end
      end
    end
  end
end
