module AlacrityRails
  module Probe
    class ActiveModelSerializers
      def self.activate
        ActiveSupport::Notifications.subscribe 'render.active_model_serializers' do |name, started, finished, unique_id, data|
          AlacrityRails::Client.store_timeline_event(
            name: 'Template',
            event_type: 'template',
            engine: 'ActiveModel::Serializers',
            started_at: started,
            finished_at: finished,
            detail: data[:serializer].to_s
          )
        end
      end
    end
  end
end
