module AlacrityRails::Transaction
  class Custom < Base
    attr_accessor :name, :start_time, :end_time

    def initialize(data={})
      self.name = data[:name]
      self.start_time = DateTime.now
    end

    def finalize(response)
      self.end_time = DateTime.now
    end

    def as_json(*args)
      {
        environment: AlacrityRails::ServerConfig.environment,
        event_type: 'custom',
        started_at: absolute_time(start_time),
        finished_at: absolute_time(end_time),
        name: name,
        timeline_events: prepared_timeline_events
      }
    end

    def self.endpoint
      @endpoint ||= URI("#{AlacrityRails::Config.collector_host}/v3/events")
    end
  end
end
