module AlacrityRails::Transaction
  class Job < Base
    attr_accessor :name, :data, :start_time, :end_time

    def initialize(data={})
      self.name = data.delete(:name)
      self.data = data
      self.start_time = DateTime.now
    end

    def finalize(response)
      self.end_time = DateTime.now
    end

    def as_json(*args)
      {
        environment: AlacrityRails::ServerConfig.environment,
        event_type: 'job',
        name: name,
        started_at: absolute_time(start_time),
        finished_at: absolute_time(end_time),
        timeline_events: prepared_timeline_events,
        data: data
      }
    end

    def self.endpoint
      @endpoint ||= URI("#{AlacrityRails::Config.collector_host}/v3/events")
    end
  end
end
